/**
 *******************************************************************************
 * @file    w25q80.h
 *
 * @brief   w25q80 head body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/
#ifndef _W25Q80_H_
#define _W25Q80_H_

#include "systick.h"
#include <stdio.h>
#include <string.h>
#include <stdint.h>

void W25QxxInit(void);
void W25QxxWriteEnable(void);
void W25QXX_Write_Disable(void);
uint16_t W25QxxReadID(void);
uint32_t W25QxxReadCapacity(void);
void W25QxxReadUniqueID(uint8_t *UID);
void W25QxxPageWrite(uint32_t add, uint8_t *data, uint16_t len);
void W25QxxReadData(uint32_t add, uint8_t *ref_buf, uint16_t len);
void W25QxxSector4kErase(uint32_t add);
void W25QxxBlock32Erase(uint32_t add);
void W25QxxBlock64Erase(uint32_t add);
void W25QxxChipErase(void);

void W25QxxDeepPowerDown(void);
void W25QxxWakeUp(void);

uint8_t W25QxxContinueWriteData(uint32_t addr, uint8_t *buf, uint32_t len);
uint8_t W25QxxContinueReadData(uint32_t addr, uint8_t *buf, uint32_t len);

#endif
